module MetProgITraPraII  where

import Mpi
import XFig

data X a b = Unid a | Comp b (X a b) (X a b)		deriving Show

type L2D = X Caixa Tipo

type Caixa = ((Int,Int),(Texto,Cor))

data Tipo = V | Vd | Ve | H | Ht | Hb		deriving Show

type Texto = String

data Cor = Vermelha | Azul | Verde | Amarela	deriving Show

type Ponto = (Int,Int)

data Fig = Fig Ponto [Obj]  deriving Show

type Obj = (Ponto,Caixa)


desenho :: L2D -> Fig
desenho (Unid c)     = desUnid c
desenho (Comp t a b) = desComp t (desenho a) (desenho b)


--------------------- interface com XFig ------

xfigcolor :: Cor -> Int
xfigcolor Azul = 11
xfigcolor Vermelha = 4
xfigcolor Verde = 2
xfigcolor Amarela = 6


geraXFcaixa :: Ponto -> Ponto -> Cor -> Object
geraXFcaixa (x1,y1) (x2,y2) c =
  Polyline (defaultBox (Pt x1 y1) (Pt x2 y2))
	       {plPenColor=xfigcolor c,
		plFillColor=xfigcolor c,
		plAreaFill=20}


geraXFtexto :: Ponto -> String -> Object
geraXFtexto (x,y) s =
  Text (defaultText (Pt x y) s)
	   {tJustification=CenterJustified}




--------------------- dados de exemplo -----------------
ex =
 (Comp Ht
  (Comp Ve 
   (Comp H  (Unid ((1000,2000),("A",Azul))) (Unid ((300,600),("B",Verde))))
   (Comp Hb (Unid ((2000,400),("C",Vermelha))) (Unid ((900,2000),("D",Amarela)))))
  (Comp Vd 
   (Comp Hb (Unid ((1200,2000),("E",Azul))) (Unid ((1500,3000),("F",Verde))))
   (Comp Ht  (Unid ((2200,800),("G",Vermelha))) (Unid ((600,3000),("H",Amarela)))))
  )


ex2=(Comp Ht  (Unid ((1000,2000),("A",Azul))) (Unid ((300,600),("B",Verde))))


ex3= Unid ((1200,2000),("Caixa azul",Azul))


exemploFig = (Fig (5000,5000)
	      [((3000,500),((1000,1000),("ABCS",Vermelha))),
	       ((1000,200),((1000,1000),("ABCS",Verde))),
	       ((1000,3000),((2000,1000),("XYZPTO",Azul)))])

----
